import { Component, Input, OnInit } from '@angular/core';
import { MonkeyModalConfig, MonkeyStyleGuideModalService } from 'monkey-style-guide';

@Component({
  selector: 'monkeyecx-alerts',
  templateUrl: './alerts.component.html',
  styleUrls: ['./alerts.component.scss']
})
export class AlertsComponent implements OnInit {
  @Input() config: MonkeyModalConfig | null = null;

  @Input() modalRef: any;

  _img = '';

  _title = '';

  _message = '';

  constructor(
    private modalService: MonkeyStyleGuideModalService
  ) {
    // not to do
  }

  ngOnInit() {
    const { config } = this;
    this._img = config?.data?.img;
    this._title = config?.data?.title;
    this._message = config?.data?.message;
  }

  onClose() {
    this.modalService.close(this.modalRef);
  }
}
