/* eslint-disable space-before-function-paren */
/* eslint-disable func-names */
/* eslint-disable max-len */
import { MonkeyUtils } from 'monkey-style-guide';
import { MonkeyEcxServiceCredentials } from '../interfaces';
import { DecoratorsUtils } from '../utils';

export function MonkeyEcxServiceUpload(
  name: string,
  description?: string,
  params?: MonkeyEcxServiceCredentials
) {
  return function (
    target: Object,
    propertyName: string,
    propertyDescriptor: PropertyDescriptor
  ): PropertyDescriptor {
    const method = propertyDescriptor.value;

    propertyDescriptor.value = function (...args: any[]) {
      const context: any = this;
      if (DecoratorsUtils.hasMonkeyEcxServiceAndHandlingProperties(context)) {
        if (MonkeyUtils.persistNullEmptyUndefined(params)) {
          context?.monkeyecxService?.monkeyecxHandlingService?.clearAll();
          context?.monkeyecxService?.monkeyecxHandlingService?.setMonkeyEcxServiceCredentials(
            params
          );
        }
        context?.monkeyecxService?.monkeyecxHandlingService?.setMonkeyEcxRequestUpload({
          ...DecoratorsUtils.buildUploadPropertys(name, description),
        });
      }
      const result = method.apply(context, args);
      return result;
    };

    return propertyDescriptor;
  };
}
