import { OverlayModule } from '@angular/cdk/overlay';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { MonkeyEcxDragDropDirective } from './monkeyecx-drag-drop';
import { MonkeyEcxFeatureByProgramDirective } from './monkeyecx-feature-by-program-directive';
import { MonkeyEcxFeatureDirective } from './monkeyecx-feature-directive';
import { MonkeyEcxFormatCurrency } from './monkeyecx-format-currency';
import { MonkeyEcxFormatUpper } from './monkeyecx-format-upper';
import { MonkeyEcxOnlyAlphaNumericDirective } from './monkeyecx-only-alpha-numeric-directive';
import { MonkeyEcxOnlyNumbersDirective } from './monkeyecx-only-number-directive';
import { MonkeyEcxPopoverOptionsDirective } from './monkeyecx-popover-options.directive';
import { MonkeyEcxPopoverDirective } from './monkeyecx-popover.directive';
import { MonkeyEcxSecurityDirective } from './monkeyecx-security-directive';
import { MonkeyEcxTooltipDirective } from './monkeyecx-tooltip-directive';

@NgModule({
  declarations: [
    MonkeyEcxDragDropDirective,
    MonkeyEcxFormatCurrency,
    MonkeyEcxFeatureDirective,
    MonkeyEcxFeatureByProgramDirective,
    MonkeyEcxFormatUpper,
    MonkeyEcxOnlyAlphaNumericDirective,
    MonkeyEcxOnlyNumbersDirective,
    MonkeyEcxSecurityDirective,
    MonkeyEcxTooltipDirective,
    MonkeyEcxPopoverDirective,
    MonkeyEcxPopoverOptionsDirective
  ],
  imports: [CommonModule, OverlayModule],
  exports: [
    MonkeyEcxDragDropDirective,
    MonkeyEcxFormatCurrency,
    MonkeyEcxFeatureDirective,
    MonkeyEcxFeatureByProgramDirective,
    MonkeyEcxFormatUpper,
    MonkeyEcxOnlyAlphaNumericDirective,
    MonkeyEcxOnlyNumbersDirective,
    MonkeyEcxSecurityDirective,
    MonkeyEcxTooltipDirective,
    MonkeyEcxPopoverDirective,
    MonkeyEcxPopoverOptionsDirective
  ]
})
export class MonkeyEcxDirectivesModule {}
