import { Directive, HostListener, Output, HostBinding, EventEmitter } from '@angular/core';

@Directive({
  selector: '[monkeyecxDragDrop]',
})
export class MonkeyEcxDragDropDirective {
  @Output() onFileDropped: EventEmitter<any> = new EventEmitter<any>();

  @HostBinding('style.background-color') private background = '#f5fcff';

  @HostBinding('style.opacity') private opacity = '1';

  @HostListener('dragover', ['$event'])
  onDragOver(evt: any) {
    evt?.preventDefault();
    evt?.stopPropagation();
    this.background = '#9ecbec';
    this.opacity = '0.8';
  }

  @HostListener('dragleave', ['$event'])
  public onDragLeave(evt: any) {
    evt?.preventDefault();
    evt?.stopPropagation();
    this.background = '#f5fcff';
    this.opacity = '1';
  }

  @HostListener('drop', ['$event'])
  public ondrop(evt: any) {
    evt?.preventDefault();
    evt?.stopPropagation();
    this.background = '#f5fcff';
    this.opacity = '1';
    const { files } = evt?.dataTransfer;
    if (files.length > 0) {
      this.onFileDropped.emit(files);
    }
  }
}
