import { Directive, forwardRef, InjectionToken, Input } from '@angular/core';

export const POPOVER_OPTIONS = new InjectionToken('POPOVER_OPTIONS');

export type PopoverDir =
  | 'rtl'
  | 'ltr'
  | 'trtl'
  | 'tltr'
  | 'ct'
  | 'cc'
  | 'cr'
  | 'rt'
  | 'rb'
  | 'lt'
  | 'lb';

export interface MonkeyEcxPopoverOptions {
  dir?: PopoverDir;
  minwidth?: boolean;
  backdrop?: boolean;
  contextmenu?: boolean;
}

@Directive({
  selector: '[monkeyecxPopoverOptions]',
  providers: [
    {
      provide: POPOVER_OPTIONS,
      useExisting: forwardRef(() => {
        // eslint-disable-next-line no-use-before-define
        return MonkeyEcxPopoverOptionsDirective;
      })
    }
  ]
})
export class MonkeyEcxPopoverOptionsDirective implements MonkeyEcxPopoverOptions {
  @Input('monkeyecxPopoverOptions')
  set options(options: MonkeyEcxPopoverOptions) {
    Object.entries(options).forEach(([k, v]) => {
      this[k] = v;
    });
  }

  minwidth?: boolean;

  dir?: PopoverDir;

  backdrop?: boolean;

  contextmenu?: boolean;
}
