import { ModuleWithProviders, NgModule } from '@angular/core';
import { HTTP_INTERCEPTORS } from '@angular/common/http';
import { CommonModule } from '@angular/common';
import { MonkeyEcxHttpConfigErrorInterceptor } from './monkeyecx-http-config-error.interceptor';
import { MonkeyEcxHttpConfigHeaderInterceptor } from './monkeyecx-http-config-header.interceptor';
import { MonkeyEcxHttpConfigQueueInterceptor } from './monkeyecx-http-config-queue.interceptor';
import { MonkeyEcxHttpConfigLoadingInProgressInterceptor } from './monkeyecx-http-config-loading-in-progress.interceptor';

@NgModule({
  imports: [CommonModule],
})
export class MonkeyEcxHttpConfigInterceptorModule {
  public static forRoot(): ModuleWithProviders<MonkeyEcxHttpConfigInterceptorModule> {
    return {
      ngModule: MonkeyEcxHttpConfigInterceptorModule,
      providers: [
        {
          provide: HTTP_INTERCEPTORS,
          useClass: MonkeyEcxHttpConfigHeaderInterceptor,
          multi: true,
        },
        {
          provide: HTTP_INTERCEPTORS,
          useClass: MonkeyEcxHttpConfigErrorInterceptor,
          multi: true,
        },
        {
          provide: HTTP_INTERCEPTORS,
          useClass: MonkeyEcxHttpConfigQueueInterceptor,
          multi: true,
        },
        {
          provide: HTTP_INTERCEPTORS,
          useClass: MonkeyEcxHttpConfigLoadingInProgressInterceptor,
          multi: true,
        },
      ],
    };
  }
}
