export class Link {
  href: string;

  type: string;

  templated: boolean;

  constructor(data?: any) {
    this.href = data?.href;
    this.type = data?.type;
    this.templated = data?.templated;
  }
}

export class MonkeyEcxModel {
  _links: any;

  public getAction(
    type: string,
    replaceOptions?: {
      from: string;
      to: string;
    }
  ): Link | null {
    const { _links } = this;
    if (!_links) return null;
    let link: Link = _links[type.toLowerCase()];
    link = new Link(link);
    if (link && replaceOptions && link?.templated) {
      const { from, to } = replaceOptions;
      link = new Link({
        ...link,
        href: `${link.href}`.replace(from, to),
      });
    }
    return link;
  }
}
