import { Pipe, PipeTransform } from '@angular/core';
import * as moment from 'moment';
import { MonkeyEcxConfigSupportPhone } from '../interfaces';

@Pipe({
  name: 'monkeyecxDisplaySupportPhone'
})
export class MonkeyEcxDisplaySupportPhone implements PipeTransform {
  constructor() {
    // not to do
  }

  transform(phones: MonkeyEcxConfigSupportPhone[]) {
    return phones.map((phone: MonkeyEcxConfigSupportPhone) => {
      const isOnline = this.isPhoneOnline(phone);

      return {
        ...phone,
        isOnline,
        color: isOnline ? '#00875A' : '#FA3838'
      };
    });
  }

  isPhoneOnline(phone: any): boolean {
    const start = moment().startOf('day').add(phone?.startHour, 'hours').format('YYYY-MM-DD HH:mm');
    const end = moment().startOf('day').add(phone?.endHour, 'hours').format('YYYY-MM-DD HH:mm');

    return moment().isSameOrAfter(start) && moment().isSameOrBefore(end);
  }
}
