import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'monkeyecxFormatAddress',
})
export class MonkeyEcxFormatAddressPipe implements PipeTransform {
  transform({
    zipCode,
    address,
    neighborhood,
    city,
    state,
  }: {
    zipCode: string;
    address: string;
    neighborhood: string;
    city: string;
    state: string;
    country: string;
  }): string {
    return [address, neighborhood, zipCode, city, state]
      .filter((_: string) => {
        return _;
      })
      .join(', ');
  }
}
