import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'monkeyecxFormatBeautifyJSON'
})
export class MonkeyEcxFormatBeaufityJSONPipe implements PipeTransform {
  constructor() {
    // not to do
  }

  transform(value: any) {
    const jsonLine = /^( *)("[\w]+": )?("[^"]*"|[\w.+-]*)?([,[{])?$/gm;

    const replacer = (match, pIndent, pKey, pVal, pEnd) => {
      const key = '<span class="json-key" style="color: brown">';
      const val = '<span class="json-value" style="color: navy">';
      const str = '<span class="json-string" style="color: olive">';
      let r = pIndent || '';
      if (pKey) {
        r = `${r + key + pKey.replace(/[": ]/g, '')}</span>: `;
      }
      if (pVal) {
        r = `${r + (pVal[0] === '"' ? str : val) + pVal}</span>`;
      }
      return r + (pEnd || '');
    };

    return JSON.stringify(value, null, 3)
      .replace(/&/g, '&amp;')
      .replace(/\\"/g, '&quot;')
      .replace(/</g, '&lt;')
      .replace(/>/g, '&gt;')
      .replace(jsonLine, replacer);
  }
}
