import { Pipe, PipeTransform, Injector } from '@angular/core';
import { CurrencyPipe } from '@angular/common';
import { MonkeyEcxCookieStorageService } from '../services/storage/monkeyecx-cookie-storage.service';

@Pipe({
  name: 'monkeyecxFormatCurrency'
})
export class MonkeyEcxFormatCurrencyPipe implements PipeTransform {
  constructor(private injector: Injector, private currencyPipe: CurrencyPipe) {
    // not to do
  }

  transform(value: any) {
    const cookieStorageService = this.injector.get(MonkeyEcxCookieStorageService);
    const cookie = cookieStorageService.getCookie('monkey-app-locale');
    const i18n = JSON.parse(atob(cookie));
    const { currency } = i18n;
    return this.currencyPipe.transform(value, currency, 'symbol');
  }
}
