import { Pipe, PipeTransform } from '@angular/core';
import * as moment_ from 'moment';
import { MonkeyEcxUtils } from '../utils';

const moment: any = moment_;

@Pipe({
  name: 'monkeyecxFormatDateUnixTimelapse'
})
export class MonkeyEcxFormatDateUnixTimelapsePipe implements PipeTransform {
  transform(date: any | Date, showTime = false, useUtc = true, format = '- HH:mm'): string {
    if (!MonkeyEcxUtils.persistNullEmptyUndefined(date)) return '';
    let stillUtc: any = moment.default.utc(date).toDate();
    if (!useUtc) stillUtc = moment.default(date).toDate();
    if (
      moment.default
        .utc(date)
        .toDate()
        .toLocaleString()
        .indexOf(':') <= -1
    ) {
      if (typeof date === 'string') {
        stillUtc = date;
        showTime = false;
      }
    }
    const formatFrom = `YYYY/MM/DD${showTime ? ` ${format}` : ''}`;
    const formatTo = `DD/MM/YYYY${showTime ? ` ${format}` : ''}`;
    return `${moment.default(stillUtc, formatFrom).format(formatTo)}`;
  }
}
