import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'monkeyecxFormatPhone'
})
export class MonkeyEcxFormatPhonePipe implements PipeTransform {
  transform(phone: string): string {
    if (phone) {
      const value = `${phone || ''}`.replace(/\D/g, '');

      let formated = '';

      if (value.length > 12) {
        formated = value.replace(/(\d{2})?(\d{2})?(\d{5})?(\d{4})/, '+$1 ($2) $3-$4');
      } else if (value.length > 11) {
        formated = value.replace(/(\d{2})?(\d{2})?(\d{4})?(\d{4})/, '+$1 ($2) $3-$4');
      } else if (value.length > 10) {
        formated = value.replace(/(\d{2})?(\d{5})?(\d{4})/, '($1) $2-$3');
      } else if (value.length > 9) {
        formated = value.replace(/(\d{2})?(\d{4})?(\d{4})/, '($1) $2-$3');
      } else if (value.length > 5) {
        formated = value.replace(/^(\d{2})?(\d{4})?(\d{0,4})/, '($1) $2-$3');
      } else if (value.length > 1) {
        formated = value.replace(/^(\d{2})?(\d{0,5})/, '($1) $2');
      } else if (phone !== '') {
        formated = value.replace(/^(\d*)/, '($1');
      }
      return formated;
    }
    return '';
  }
}
