import { Pipe, PipeTransform } from '@angular/core';
import { MonkeyEcxUtils } from '../utils';

@Pipe({
  name: 'monkeyecxFormatTax',
})
export class MonkeyEcxFormatTaxPipe implements PipeTransform {
  transform(tax: number, decimalDigits: number = 7) {
    if (!MonkeyEcxUtils.persistNullEmptyUndefined(tax)) return '0 %';
    const stringTax = tax.toString();
    const stringTaxLimited = stringTax.slice(0, stringTax.indexOf('.') + decimalDigits + 1);
    return `${Number(stringTaxLimited).toLocaleString('pt-br', {
      maximumFractionDigits: decimalDigits,
    })} %`;
  }
}
