import { Injectable } from '@angular/core';
import { CanActivate } from '@angular/router';
import { Observable } from 'rxjs';
import { MonkeyEcxAuthenticationService } from './monkeyecx-authentication.service';

@Injectable({ providedIn: 'root' })
export class MonkeyEcxAuthGuardCompany implements CanActivate {
  constructor(private monkeyecxAuthenticationService: MonkeyEcxAuthenticationService) {
    // not to do
  }

  canActivate(): Observable<boolean> | Promise<boolean> | boolean {
    const { monkeyecxAuthenticationService } = this;

    if (this.monkeyecxAuthenticationService.isAuthorized()) {
      if (monkeyecxAuthenticationService.isCompanyAuthorized()) {
        return true;
      }
      this.monkeyecxAuthenticationService.redirectApp();
      return false;
    }

    monkeyecxAuthenticationService.redirectLoginWelcomeBack();

    return false;
  }
}
