import { Injectable } from '@angular/core';
import { CanActivate } from '@angular/router';
import { Observable } from 'rxjs';
import { MonkeyEcxAuthenticationService } from './monkeyecx-authentication.service';

@Injectable({ providedIn: 'root' })
export class MonkeyEcxAuthGuardLogin implements CanActivate {
  constructor(private monkeyecxAuthenticationService: MonkeyEcxAuthenticationService) {
    // not to do
  }

  canActivate(): Observable<boolean> | Promise<boolean> | boolean {
    if (this.monkeyecxAuthenticationService.isAuthorized()) {
      this.monkeyecxAuthenticationService.redirectApp();
      return false;
    }
    if (this.monkeyecxAuthenticationService.hadAtLeastOneLogin()) {
      this.monkeyecxAuthenticationService.redirectLoginWelcomeBack();
      return false;
    }
    return true;
  }
}
