import { Injectable } from '@angular/core';
import { CanActivate } from '@angular/router';
import { Observable } from 'rxjs';
import { MonkeyEcxAuthenticationService } from './monkeyecx-authentication.service';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxAuthGuard implements CanActivate {
  constructor(private monkeyecxAuthenticationService: MonkeyEcxAuthenticationService) {
    // not to do
  }

  canActivate(): Observable<boolean> | Promise<boolean> | boolean {
    const { monkeyecxAuthenticationService } = this;

    if (monkeyecxAuthenticationService.isAuthorized()) {
      return true;
    }

    monkeyecxAuthenticationService.redirectLoginWelcomeBack();

    return false;
  }
}
