import { Injectable } from '@angular/core';
import { MonkeyStyleGuideModalFixedService } from 'monkey-style-guide';
import * as moment_ from 'moment';
import { MonkeyEcxConfig } from '../../interfaces';
import { AlertsComponent } from '../../../components';

const moment: any = moment_;

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxAlertsConfigService {
  constructor(private modalService: MonkeyStyleGuideModalFixedService) {
    // not to do
  }

  private handleValidation(config: MonkeyEcxConfig) {
    if (config.alert) {
      const { img, title, message, endDate } = config.alert;
      if (moment.default().isSameOrBefore(moment.default(endDate))) {
        this.modalService.open(AlertsComponent, {
          color: 'theme',
          size: 'md',
          data: {
            img,
            title,
            message
          }
        });
      }
    }
  }

  public apply(config: MonkeyEcxConfig) {
    this.handleValidation(config);
  }
}
