/* eslint-disable prefer-rest-params */
import { Injectable } from '@angular/core';
import { NavigationEnd, Router } from '@angular/router';
import { MonkeyEcxConfig } from '../../interfaces';

declare const window: any;

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxGAConfigService {
  constructor(private rt: Router) {
    // not to do
  }

  public apply(params: MonkeyEcxConfig, environment: any) {
    const { ga } = params;
    const { enabled, key } = ga || { enabled: false, key: '' };
    if (enabled && environment.environment !== 'dev') {
      const action = () => {
        window.dataLayer = window.dataLayer || [];
        window.gtag =
          window.gtag ||
          function gtag() {
            window.dataLayer.push(arguments);
          };

        window.gtag('js', new Date());
        window.gtag('config', key);
      };

      const pageChangeAction = () => {
        this.rt.events.subscribe((event: any) => {
          if (event instanceof NavigationEnd) {
            window.gtag('set', 'page_path', event.url);
            window.gtag('event', 'page_view');
          }
        });
      };

      const head = document.querySelector('head');
      const script = document.createElement('script');
      script.async = true;
      script.id = 'ga-settings';
      script.src = `//www.googletagmanager.com/gtag/js?id=${key}`;
      script.onload = () => {
        action();
        pageChangeAction();
      };
      script.onerror = () => {
        head?.removeChild(script);
      };
      head?.appendChild(script);
    }
  }
}
