import { Injectable } from '@angular/core';
import { datadogRum } from '@datadog/browser-rum';
import { MonkeyEcxConfig, MonkeyEcxConfigBoostrap } from '../../interfaces';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxLogsConfigService {
  public apply(
    params: MonkeyEcxConfig,
    configBoostrap: MonkeyEcxConfigBoostrap,
    environment: any,
    identifyCode: string
  ) {
    const { program, logs } = params;
    if (logs?.enabled && environment.environment !== 'dev') {
      datadogRum.init({
        applicationId: environment?.dataDogApplicationId,
        clientToken: environment?.dataDogClientToken,
        service: program?.token,
        site: 'datadoghq.com',
        sampleRate: 100,
        replaySampleRate: 100,
        env: `monkey-front-${identifyCode}-${environment.environment}`,
        version: configBoostrap?.version,
        trackInteractions: true,
        trackSessionAcrossSubdomains: true,
        useSecureSessionCookie: true,
        useCrossSiteSessionCookie: true
      });
      datadogRum.startSessionReplayRecording();
    }
  }
}
