import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { MonkeyStyleGuideModalService } from 'monkey-style-guide';
import { ClosedToMaintenanceComponent } from '../../../components/closed-to-maintenance/closed-to-maintenance.component';
import { MonkeyEcxConfigBoostrap } from '../../interfaces/monkeyecx-config-boostrap';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxMaintenanceConfigService {
  constructor(private modalService: MonkeyStyleGuideModalService, private router: Router) {
    // not to do
  }

  private handleValidation(config: MonkeyEcxConfigBoostrap) {
    if (config.maintenance.closed) {
      localStorage.clear();
      this.router.navigate(['']);

      setTimeout(() => {
        this.modalService.open(ClosedToMaintenanceComponent, {
          color: 'theme',
          size: 'md',
          data: config
        });
      }, 200);
    }
  }

  public apply(config: MonkeyEcxConfigBoostrap) {
    this.handleValidation(config);
  }
}
