/* eslint-disable no-console */
import { Injectable } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { MonkeyEcxCommonsService } from '../commons';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxSecurityConsoleConfigService extends MonkeyEcxCommonsService {
  constructor(private translateService: TranslateService) {
    super();

    this.geti18n(this.translateService, 'SERVICES.WARNING.CONSOLE');
  }

  private handleValidation() {
    this.__oni18nDataChanged$.subscribe(() => {
      const { __i18n } = this;
      const title = __i18n?.TITLE;
      const message = __i18n?.MESSAGE;
      if (title) {
        console.log(`%c${title}`, 'background: #f2f061; color: #ff0000; font-size: x-large');
        console.log(`%c${message}`, 'font-size: x-large');
        console.log(
          '%c  __  __             _             ______   \n ' +
          '|  \\/  | ___  _ __ | | _____ _   _\\ \\ \\ \\  \n ' +
          "| |\\/| |/ _ \\| '_ \\| |/ / _ \\ | | |\\ \\ \\ \\ \n " +
          '| |  | | (_) | | | |   <  __/ |_| |/ / / / \n ' +
          '|_|  |_|\\___/|_| |_|_|\\_\\___|\\__, /_/_/_/  \n ' +
          '                             |___/         \n ' +
          'Join us: https://monkeyecx.gupy.io', 'background: #1976d2; color: #fff'
        );
      }
    });
  }

  public apply() {
    this.handleValidation();
  }
}
