import {
  Injectable, Injector, ErrorHandler
} from '@angular/core';
import { HttpErrorResponse } from '@angular/common/http';
import { MonkeyEcxHttpErrorHandlingService } from './monkeyecx-http-error-handling.service';
import { MonkeyEcxHandlingService } from '../monkeyecx-handling.service';
import { MonkeyEcxOthersErrorsHandlingService } from './monkeyecx-others-errors-handling.service';
import { MonkeyEcxUtils } from '../../utils/utils';
import { MonkeyEcxServiceCredentials } from '../../interfaces';

@Injectable({ providedIn: 'root' })
export class MonkeyEcxErrorHandlingService implements ErrorHandler {
  constructor(private injector: Injector) {
    // not to do
  }

  handleError(error: any, type?: string) {
    const { injector } = this;
    const handlingService = injector.get(MonkeyEcxHandlingService);
    const httpErrorHandlingService = injector.get(MonkeyEcxHttpErrorHandlingService);
    const othersErrorsHandlingService = injector.get(MonkeyEcxOthersErrorsHandlingService);

    if (error instanceof HttpErrorResponse) {
      const sCredentials: MonkeyEcxServiceCredentials =
        handlingService?.getMonkeyEcxServiceCredentials() || {};
      if (MonkeyEcxUtils.persistNullEmptyUndefined(type) && type === 'refresh_token') {
        httpErrorHandlingService.handleErrorRefreshToken(error, sCredentials);
      } else httpErrorHandlingService.handleError(error, sCredentials);
    } else {
      othersErrorsHandlingService.handleError(error);
    }
  }
}
