import { Injectable } from '@angular/core';
import { MonkeyEcxRequestSchedule } from '../../interfaces';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxLoggedHandlingService {
  private schedules: MonkeyEcxRequestSchedule[] = [];

  private genericSchedules: MonkeyEcxRequestSchedule[] = [];

  constructor() {
    // not to do
  }

  private destroySchedule() {
    this.schedules.forEach((sch: MonkeyEcxRequestSchedule) => {
      clearInterval(sch.interval);
    });
    this.schedules = [];
  }

  private destroyGenericSchedule() {
    this.genericSchedules.forEach((sch: MonkeyEcxRequestSchedule) => {
      clearInterval(sch.interval);
    });
    this.genericSchedules = [];
  }

  public addSchedule(sch: MonkeyEcxRequestSchedule[]) {
    this.schedules = sch;
  }

  public addGenericSchedule(sch: MonkeyEcxRequestSchedule[]) {
    this.genericSchedules = sch;
  }

  public destroy() {
    this.destroySchedule();
    this.destroyGenericSchedule();
  }
}
