/* eslint-disable max-len */
import { Injectable } from '@angular/core';
import { MonkeyEcxRequestDownload } from '../interfaces/request-download/monkeyecx-request-download';
import { MonkeyEcxRequestQueue } from '../interfaces/request-queue/monkeyecx-request-queue';
import { MonkeyEcxRequestUpload } from '../interfaces/request-upload/monkeyecx-request-upload';
import { MonkeyEcxServiceCredentials } from '../interfaces/monkeyecx-service-credentials';

@Injectable({
  providedIn: 'root'
})
export abstract class MonkeyEcxHandlingService {
  private monkeyecxServiceCredentials: MonkeyEcxServiceCredentials | null = null;

  private monkeyecxRequestQueue: MonkeyEcxRequestQueue | null = null;

  private monkeyecxRequestDownload: MonkeyEcxRequestDownload | null = null;

  private monkeyecxRequestUpload: MonkeyEcxRequestUpload | null = null;

  public clearAll() {
    this.monkeyecxServiceCredentials = null;
    this.monkeyecxRequestQueue = null;
    this.monkeyecxRequestDownload = null;
    this.monkeyecxRequestUpload = null;
  }

  public setMonkeyEcxServiceCredentials(param: MonkeyEcxServiceCredentials) {
    this.monkeyecxServiceCredentials = param;
  }

  public getMonkeyEcxServiceCredentials(): MonkeyEcxServiceCredentials | null {
    return this.monkeyecxServiceCredentials;
  }

  public setMonkeyEcxRequestQueue(queue: MonkeyEcxRequestQueue) {
    this.monkeyecxRequestQueue = queue;
  }

  public getMonkeyEcxRequestQueue(): MonkeyEcxRequestQueue | null {
    return this.monkeyecxRequestQueue;
  }

  public setMonkeyEcxRequestDownload(download: MonkeyEcxRequestDownload) {
    this.monkeyecxRequestDownload = download;
  }

  public getMonkeyEcxRequestDownload(): MonkeyEcxRequestDownload | null {
    return this.monkeyecxRequestDownload;
  }

  public setMonkeyEcxRequestUpload(upload: MonkeyEcxRequestUpload) {
    this.monkeyecxRequestUpload = upload;
  }

  public getMonkeyEcxRequestUpload(): MonkeyEcxRequestUpload | null {
    return this.monkeyecxRequestUpload;
  }
}
