import { Injectable } from '@angular/core';
import { Router, ActivatedRouteSnapshot } from '@angular/router';
import { MonkeyEcxUtils } from '../../utils/utils';

@Injectable({
  providedIn: 'root'
})
export class MonkeyEcxDiscoveryParamsService {
  constructor(private router: Router) {
    // not to do
  }

  private getLastChild(route: ActivatedRouteSnapshot): ActivatedRouteSnapshot {
    if (route.firstChild) {
      return this.getLastChild(route.firstChild);
    }

    return route;
  }

  public setData(field: string, value: any): any {
    const { root } = this.router.routerState.snapshot;
    const route: ActivatedRouteSnapshot = this.getLastChild(root);
    route.data[field] = value;
  }

  public getData(field: string): any {
    const { root } = this.router.routerState.snapshot;
    const route: ActivatedRouteSnapshot = this.getLastChild(root);

    const found: any = MonkeyEcxUtils.persistNullEmptyUndefined(route) ? route.data[field] : null;
    return found;
  }

  public getDataFromCurrentNavigation(field: string): any {
    const navigation = this.router.getCurrentNavigation();
    let state: any = null;
    if (MonkeyEcxUtils.persistNullEmptyUndefined(navigation)) {
      state = navigation?.extras.state;
    }

    return state ? state[field] : null;
  }

  public getParam(param: string): string | null {
    const { root } = this.router.routerState.snapshot;
    const route: ActivatedRouteSnapshot = this.getLastChild(root);
    let found: string = MonkeyEcxUtils.persistNullEmptyUndefined(route)
      ? route?.paramMap?.get(param) || ''
      : '';
    if (!MonkeyEcxUtils.persistNullEmptyUndefined(found)) found = this.getData(param);
    return found;
  }
}
