import {
  MonkeyEcxRequestDownload,
  MonkeyEcxRequestItemQueue,
  MonkeyEcxRequestQueue,
  MonkeyEcxRequestUpload
} from '../interfaces';
import * as Statics from './statics';
import { MonkeyEcxUtils } from './utils';

export function buildQueuePropertys(queue: MonkeyEcxRequestItemQueue): MonkeyEcxRequestQueue {
  const params: MonkeyEcxRequestQueue = {
    item: {
      ...queue,
      id: MonkeyEcxUtils.getRandomString(40)
    },
    status: Statics.MonkeyEcxQueueEvents.OnGoing
  };

  return params;
}

export function buildDownloadPropertys(
  name: string,
  description?: string,
  size?: number
): MonkeyEcxRequestDownload {
  const params: MonkeyEcxRequestDownload = {
    item: {
      name,
      description,
      id: `${MonkeyEcxUtils.getRandomString(40)}`,
      size,
      createdAt: new Date()
    },
    status: Statics.MonkeyEcxQueueEvents.OnGoing
  };

  return params;
}

export function buildUploadPropertys(name: string, description?: string): MonkeyEcxRequestUpload {
  const params: MonkeyEcxRequestUpload = {
    item: {
      name,
      description,
      id: `${MonkeyEcxUtils.getRandomString(40)}`
    },
    status: Statics.MonkeyEcxUploadEvents.OnGoing
  };

  return params;
}

export function hasMonkeyEcxServiceAndHandlingProperties(context: any): boolean {
  return Object.prototype.hasOwnProperty.call(context, 'monkeyecxService');
}
