/* eslint-disable comma-dangle */
/* eslint-disable max-len */
/* eslint-disable no-useless-escape */
/* eslint-disable no-plusplus */
/* eslint-disable no-cond-assign */
/* eslint-disable eqeqeq */
/* eslint-disable no-redeclare */
/* eslint-disable vars-on-top */
/* eslint-disable no-var */
/* eslint-disable block-scoped-var */
export class MonkeyEcxUtils {
  static persistNullEmptyUndefined(tp: any): boolean {
    return tp !== null && tp !== undefined && tp !== '';
  }

  static getDocumentType(doc: string, country?: string) {
    if (!doc) return '';
    if (country === 'cl') return 'RUT';
    return doc.length <= 11 ? 'CPF' : 'CNPJ';
  }

  static getDocumentMask(type: string) {
    if (type === 'CPF') return '000.000.000-00';
    return '00.000.000/0000-00';
  }

  static formatDocumentWithMask(doc: string, withType?: boolean, country?: string): string {
    if (!doc) return doc;
    let formated: string = '';
    if (country === 'cl') {
      formated = doc.replace(/^(\d{1,2})(\d{3})(\d{3})(\w{1})$/, '$1.$2.$3-$4');
      return `${formated}`;
    }
    if (doc.length === 14) {
      formated = doc
        .replace(/^(\d{2})(\d)/, '$1.$2')
        .replace(/^(\d{2})\.(\d{3})(\d)/, '$1.$2.$3')
        .replace(/\.(\d{3})(\d)/, '.$1/$2')
        .replace(/(\d{4})(\d)/, '$1-$2');
    } else {
      formated = doc
        .replace(/^(\d{3})(\d)/, '$1.$2')
        .replace(/^(\d{3})\.(\d{3})(\d)/, '$1.$2.$3')
        .replace(/\.(\d{3})(\d)/, '.$1-$2');
    }

    return `${withType ? `${this.getDocumentType(doc)}:` : ''} ${formated}`;
  }

  static cutFirstLastName(value: string, tp: string = 'first') {
    const split = value?.trim()?.split(' ');

    if (tp === 'first') return split[0];
    return split?.splice(1, split.length)?.join(' ');
  }

  static isCPFCNPJValid(document: any): boolean {
    document = document.replace(/[^\d]/g, '');

    const handled = document.replace(new RegExp(document.charAt(0), 'g'), '');
    if (!handled) return false;

    if (document.length === 11) {
      let base = [10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0];
      for (var i = 0, n = 0; i < 9; n += document[i] * base[i++]);
      if (document[9] != ((n %= 11) <= 1 ? 0 : 11 - n)) {
        return false;
      }
      base = [11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0];
      for (var i = 0, n = 0; i <= 9; n += document[i] * base[i++]);
      if (document[10] != ((n %= 11) <= 1 ? 0 : 11 - n)) {
        return false;
      }
      return true;
    }
    if (document.length === 14 || /0{14}/.test(document)) {
      const base = [6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2];
      for (var i = 0, n = 0; i < 12; n += document[i] * base[++i]);
      if (document[12] != ((n %= 11) < 2 ? 0 : 11 - n)) {
        return false;
      }

      for (var i = 0, n = 0; i <= 12; n += document[i] * base[i++]);
      if (document[13] != ((n %= 11) < 2 ? 0 : 11 - n)) {
        return false;
      }

      return true;
    }
    return false;
  }

  public static isValidRUT(document: string): boolean {
    if (!document || document.trim().length < 3) return false;
    const documentHandled = document.replace(/[^0-9kK]/g, '');

    if (documentHandled.length < 3) return false;

    const calcDv = (rut: string) => {
      const value: string = `${rut}`;
      let sum = 0;
      let mult = 2;

      for (let i = 1; i <= value.length; i++) {
        const index = mult * Number(value.charAt(value.length - i));

        sum += index;

        if (mult < 7) {
          mult += 1;
        } else {
          mult = 2;
        }
      }

      const dvEsperado = 11 - (sum % 11);
      if (dvEsperado === 10) return 'K';
      if (dvEsperado === 11) return '0';
      return `${dvEsperado}`;
    };

    const num = documentHandled.slice(0, -1);
    const dgv = documentHandled.slice(-1).toUpperCase();

    const dvCalc = calcDv(num);
    return dvCalc === dgv;
  }

  static isValidUrl(txt: string): boolean {
    const regex = new RegExp(
      /^(http:\/\/www\.|https:\/\/www\.|http:\/\/|https:\/\/)+[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,10}(:[0-9]{1,5})?(\/.*)?$/gm
    );
    return regex.test(txt);
  }

  static isValidZipCode(zipCode: string): boolean {
    return `${this.handleOnlyNumbers(zipCode)}`.length === 8;
  }

  static getRandomString(len: number, charSet?: string): string {
    charSet = charSet || 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

    const randomString: string = new Array(len)
      .fill('1')
      .map(() => {
        return charSet?.charAt(Math.floor(Math.random() * charSet?.length));
      })
      .join('');
    return randomString;
  }

  static handleOnlyNumbers(value: any) {
    if (!value) return null;
    return value.replace(new RegExp(/[^0-9]/g), '');
  }

  static handleOnlyAlphaNumeric(value: any) {
    if (!value) return '';
    return value.replace(new RegExp(/[^0-9A-Za-z]/, 'g'), '');
  }

  static capitalize(value: string) {
    return `${value.charAt(0).toUpperCase()}${value.slice(1)}`;
  }

  static formatZipCode(zipCode: string): string {
    if (!zipCode) return zipCode;
    const formated: string = zipCode
      .replace(/^(\d{5})(\d)/, '$1-$2')
      .replace(/\.(\d{3})(\d)/, '.$1-$2');

    return `${formated}`;
  }

  static formatFileSize(size: number): string {
    const units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    let l = 0;
    while (size >= 1024 && ++l) {
      size /= 1024;
    }
    return `${size.toFixed(size < 10 && l > 0 ? 1 : 0)} ${units[l]}`;
  }

  static sufflue(data: any[]): any[] {
    for (let i = data.length - 1; i > 0; i--) {
      const j = Math.floor(Math.random() * i);
      const temp = data[i];
      data[i] = data[j];
      data[j] = temp;
    }
    return data;
  }

  static handleBlobFile(theBlob: any, fileName: string, fileType: string) {
    function blobToFile(theBlob: any, fileName: string) {
      const b = theBlob;
      b.lastModifiedDate = new Date();
      b.name = fileName;
      return b;
    }

    let file: any;
    if (!(navigator as any).msSaveBlob) {
      file = new File([theBlob], fileName, {
        type: fileType,
      });
    } else {
      file = new Blob([theBlob], {
        type: fileType,
      });
      file = blobToFile(file, fileName);
    }
    return file;
  }

  static truncate(text: string, maxLength: number = 25): string {
    const midChar = '...';
    if (!text) return midChar;
    if (text && text.length <= maxLength) return text;

    const left = Math.ceil(maxLength / 2);
    const right = text.length - left + 1;

    return `${text.substr(0, left)} ${midChar} ${text.substring(right)}`;
  }

  static isLocalhost() {
    const { href } = window?.location;
    if (!href) return false;
    return href?.search('localhost') >= 0;
  }

  static isSameOrigin(frontend: string): boolean {
    const initialPath: string = window.location.origin;
    return (initialPath || '') === frontend;
  }
}
