import { NgModule } from '@angular/core';
import { HttpClientModule } from '@angular/common/http';
import { CommonModule } from '@angular/common';
import {
  MonkeyStyleGuideModalService,
  MonkeyStyleGuideModule,
  MonkeyStyleGuideSettingsService,
  MonkeyStyleGuideSnackbarService
} from 'monkey-style-guide';
import { TranslateModule } from '@ngx-translate/core';
import { ServiceWorkerModule } from '@angular/service-worker';
import { ClosedToMaintenanceModule, VersionChangedModule, AlertsModule } from './components';
import { MonkeyEcxConfigModule } from './core/services/config/monkeyecx-config.module';
import { MonkeyEcxHttpConfigInterceptorModule } from './core/interceptors/monkeyecx-http-config-interceptor.module';
import { MonkeyEcxErrorHandlingModule } from './core/services/error/monkeyecx-error-handling.module';

@NgModule({
  imports: [
    CommonModule,
    HttpClientModule,
    TranslateModule.forRoot(),
    MonkeyEcxConfigModule.forRoot(),
    MonkeyEcxHttpConfigInterceptorModule.forRoot(),
    MonkeyEcxErrorHandlingModule.forRoot(),
    MonkeyStyleGuideModule,
    ServiceWorkerModule.register('ngsw-worker.js'),
    ClosedToMaintenanceModule,
    VersionChangedModule,
    AlertsModule
  ],
  providers: [
    MonkeyStyleGuideModalService,
    MonkeyStyleGuideSettingsService,
    MonkeyStyleGuideSnackbarService
  ]
})
export class MonkeyFrontCoreModule {}
